<template>
  <v-list-item v-if="client.user" @click="isMinified=false">
    <v-list-item-icon>
      <v-icon>mdi-account</v-icon>
    </v-list-item-icon>
    <v-list-item-content>
      <v-list-item-title v-text="client.user.name" />
    </v-list-item-content>
    <v-list-item-action @click="changePassword()">
      <v-tooltip left>
        <template #activator="{on, attrs}">
          <v-btn
            small icon
            v-bind="attrs"
            v-on="on"
          >
            <v-icon>mdi-account-key</v-icon>
          </v-btn>
        </template>
        {{ $t('button.chpwd') }}
      </v-tooltip>
    </v-list-item-action>
    <v-list-item-action @click="logout">
      <v-tooltip left>
        <template #activator="{on, attrs}">
          <v-btn
            small icon
            v-bind="attrs"
            v-on="on"
          >
            <v-icon>mdi-logout</v-icon>
          </v-btn>
        </template>
        {{ $t('button.logout') }}
      </v-tooltip>
    </v-list-item-action>
  </v-list-item>
  <div v-else class="mb-1">
    <v-list-item @click="login()">
      <v-list-item-icon>
        <v-icon>mdi-login</v-icon>
      </v-list-item-icon>
      <v-list-item-content>
        <v-list-item-title>
          {{ $t('button.login') }}
        </v-list-item-title>
      </v-list-item-content>
    </v-list-item>
  </div>
</template>

<script lang="ts">
import {
  Vue, Component, Prop, VModel,
} from 'vue-property-decorator';
import type { Client } from '@/client';
import { showLogin, showChangePassword } from '@/components/dialogs';

@Component
export default class LoginButton extends Vue {
  @Prop()
  client!: Client;

  @VModel()
  isMinified!: boolean;

  changePassword() {
    showChangePassword(this.client);
  }

  async login() {
    if (!this.client.user && await showLogin(this.client)) this.refreshCorpusAndReloadPage();
  }

  logout() {
    Vue.set(this.client, 'user', null);
    this.refreshCorpusAndReloadPage();
  }

  async refreshCorpusAndReloadPage() {
    await this.client.loadCorpus(true);
    this.$router.go(0);
  }
}
</script>
<style lang="scss" scoped>
// Fix bug on chrome where actions change the size of element
.v-navigation-drawer .v-list-item__action {
  margin-top: 0px;
  margin-bottom: 0px;
}
</style>
